searchData={"items":[{"type":"module","title":"ZabbixSender","doc":"Zabbix Sender Protocol client","ref":"ZabbixSender.html"},{"type":"module","title":"Examples - ZabbixSender","doc":"value = ZabbixSender.Protocol.value(\"localhost\", \"some_key\", 12.3, :os.system_time(:second))\n    request = ZabbixSender.Protocol.encode_request([value], :os.system_time(:second))\n    |> ZabbixSender.Serializer.serialize()\n\n    with {:ok, response} <- ZabbixSender.send(request, \"localhost\", 10051),\n      {:ok, deserialized} <- ZabbixSender.Serializer.deserialize(response),\n      {:ok, decoded} <- ZabbixSender.Protocol.decode_response(deserialized)\n    do\n      if decoded.failed == 0 do\n        Logger.info(\"#{decoded.processed} values processed\")\n      else\n        Logger.warn(\"#{decoded.processed} values processed out of #{decoded.total}\")\n      end\n    end","ref":"ZabbixSender.html#module-examples"},{"type":"function","title":"ZabbixSender.send/3","doc":"Sends binary message to zabbix trapper endpoint and receives response.\nReturns binary response or an error.","ref":"ZabbixSender.html#send/3"},{"type":"function","title":"Examples - ZabbixSender.send/3","doc":"iex> ZabbixSender.send(<<>>, \"localhost\", 12345)\n    {:error, :econnrefused}","ref":"ZabbixSender.html#send/3-examples"},{"type":"function","title":"ZabbixSender.send_values/4","doc":"Sends values collection to zabbix trapper endpoint and receives response.\nReturns deserialized response or an error.","ref":"ZabbixSender.html#send_values/4"},{"type":"function","title":"Examples - ZabbixSender.send_values/4","doc":"iex> ZabbixSender.send_values([%{\"key\" => \"value\"}], 123412, \"localhost\", 12345)\n    {:error, :econnrefused}","ref":"ZabbixSender.html#send_values/4-examples"},{"type":"module","title":"ZabbixSender.LLDPusher","doc":"Zabbix LLD pusher server. Attempts to send LLD via Zabbix Sender Protocol","ref":"ZabbixSender.LLDPusher.html"},{"type":"module","title":"Usage - ZabbixSender.LLDPusher","doc":"def zabbix_config() do\n    [host: \"zabbix.host\", port: 1234, hostname: \"monitored.host\"]\n  end\n\n  def zabbix_llds() do\n    [\n      some_trapper_key:\n        for val <- [1, 2] do\n          %{\n            \"{#VAL}\" => \"#{val}\",\n          }\n        end,\n    ]\n  end\n\n  children = [\n    {ZabbixSender.LLDPusher,\n       llds_provider: &__MODULE__.zabbix_llds/0, config_provider: &__MODULE__.zabbix_config/0}\n  ]","ref":"ZabbixSender.LLDPusher.html#module-usage"},{"type":"function","title":"ZabbixSender.LLDPusher.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ZabbixSender.LLDPusher.html#child_spec/1"},{"type":"function","title":"ZabbixSender.LLDPusher.start_link/1","doc":"","ref":"ZabbixSender.LLDPusher.html#start_link/1"},{"type":"module","title":"ZabbixSender.Protocol","doc":"Helper module for creating Zabbix Sender Protocol messages and parsing responses","ref":"ZabbixSender.Protocol.html"},{"type":"function","title":"ZabbixSender.Protocol.decode_response/1","doc":"Decodes zabbix sender data response.","ref":"ZabbixSender.Protocol.html#decode_response/1"},{"type":"function","title":"Examples - ZabbixSender.Protocol.decode_response/1","doc":"iex> ZabbixSender.Protocol.decode_response(%{\"response\" => \"success\", \"info\" => \"processed: 1; failed: 1; total: 2; seconds spent: 0.000055\"})\n    {:ok, %{failed: 1, processed: 1, seconds_spent: 5.5e-5, total: 2}}\n    iex> ZabbixSender.Protocol.decode_response(%{\"response\" => \"success\", \"info\" => \"failed: 1; total: 2; seconds spent: 0.000055\"})\n    {:ok, %{failed: 1, processed: nil, seconds_spent: 5.5e-5, total: 2}}\n    iex> ZabbixSender.Protocol.decode_response(%{\"response\" => \"error\"})\n    {:error, :unexpected_response}","ref":"ZabbixSender.Protocol.html#decode_response/1-examples"},{"type":"function","title":"ZabbixSender.Protocol.encode_request/2","doc":"Encodes zabbix sender data request.","ref":"ZabbixSender.Protocol.html#encode_request/2"},{"type":"function","title":"Examples - ZabbixSender.Protocol.encode_request/2","doc":"iex> ZabbixSender.Protocol.encode_request([%{\"key\" => \"value\"}], 1570451084)\n    %{clock: 1570451084, data: [%{\"key\" => \"value\"}], request: \"sender data\"}","ref":"ZabbixSender.Protocol.html#encode_request/2-examples"},{"type":"function","title":"ZabbixSender.Protocol.value/4","doc":"Builds zabbix value.","ref":"ZabbixSender.Protocol.html#value/4"},{"type":"function","title":"Examples - ZabbixSender.Protocol.value/4","doc":"iex> ZabbixSender.Protocol.value(\"localhost\", \"key\", 1.23, 1570451084)\n    %{clock: 1570451084, host: \"localhost\", key: \"key\", value: \"1.23\"}\n    iex> ZabbixSender.Protocol.value(\"localhost\", \"key\", 23, nil)\n    %{host: \"localhost\", key: \"key\", value: \"23\"}","ref":"ZabbixSender.Protocol.html#value/4-examples"},{"type":"type","title":"ZabbixSender.Protocol.response_t/0","doc":"Response from Zabbix Server","ref":"ZabbixSender.Protocol.html#t:response_t/0"},{"type":"module","title":"ZabbixSender.Serializer","doc":"Helper module for binary serialization with Zabbix Sender Protocol","ref":"ZabbixSender.Serializer.html"},{"type":"function","title":"ZabbixSender.Serializer.deserialize/1","doc":"Deserializes zabbix sender binary message to elixir data.","ref":"ZabbixSender.Serializer.html#deserialize/1"},{"type":"function","title":"Examples - ZabbixSender.Serializer.deserialize/1","doc":"iex> ZabbixSender.Serializer.deserialize(<<\"ZBXD\\x01\"::binary, 2::little-integer-size(64), \"{}\"::binary>>)\n    {:ok, %{}}\n    iex> ZabbixSender.Serializer.deserialize(<<\"ZBX\\x01\"::binary, 1::little-integer-size(64), \"{}\"::binary>>)\n    {:error, :invalid_format}\n    iex> ZabbixSender.Serializer.deserialize(<<>>)\n    {:error, :invalid_format}\n    iex> ZabbixSender.Serializer.deserialize(<<\"ZBXD\\x02\"::binary, 2::little-integer-size(64), \"{}\"::binary>>)\n    {:error, :unsupported_version}\n    iex> ZabbixSender.Serializer.deserialize(<<\"ZBXD\\x01\"::binary, 2::little-integer-size(64), \"{\"::binary>>)\n    {:error, :invalid_format}\n    iex> ZabbixSender.Serializer.deserialize(<<\"ZBXD\\x01\"::binary, 1::little-integer-size(64), \"{}\"::binary>>)\n    {:error, :invalid_format}\n    iex> ZabbixSender.Serializer.deserialize(<<\"ZBXD\\x01\"::binary, 2::little-integer-size(64), \"{w\"::binary>>)\n    {:error, %Jason.DecodeError{data: \"{w\", position: 1, token: nil}}","ref":"ZabbixSender.Serializer.html#deserialize/1-examples"},{"type":"function","title":"ZabbixSender.Serializer.serialize/1","doc":"Serializes message to zabbix sender binary format.","ref":"ZabbixSender.Serializer.html#serialize/1"},{"type":"function","title":"Examples - ZabbixSender.Serializer.serialize/1","doc":"iex> ZabbixSender.Serializer.serialize(%{})\n    <<\"ZBXD\\x01\"::binary, 2::little-integer-size(64), \"{}\"::binary>>","ref":"ZabbixSender.Serializer.html#serialize/1-examples"},{"type":"extras","title":"ZabbixSender","doc":"# ZabbixSender\n\nZabbix Sender Protocol client. Compatible with [Zabbix 4.0](https://zabbix.org/wiki/Docs/protocols/zabbix_sender/4.0)\n\nThis library implements a simple TCP client as well as helper functions for encoding and decoding protocol messages.","ref":"readme.html"},{"type":"extras","title":"Installation - ZabbixSender","doc":"The package can be installed by adding `zabbix_sender` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:zabbix_sender, \"~> 1.0.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - ZabbixSender","doc":"Use functions from `ZabbixSender.Protocol` for building requests and decoding responses.\nUse `ZabbixSender.Serializer` for writting and reading binary messages.\n`ZabbixSender.send\\3` will open connection, send request receive a response and then close the connection as the server won't allow it remain open.","ref":"readme.html#usage"},{"type":"extras","title":"Example - ZabbixSender","doc":"```elixir\nvalue = ZabbixSender.Protocol.value(\"localhost\", \"some_key\", 12.3, :os.system_time(:second))\nrequest = ZabbixSender.Protocol.encode_request([value], :os.system_time(:second))\n|> ZabbixSender.Serializer.serialize()\n\nwith {:ok, response} <- ZabbixSender.send(request, \"localhost\", 10051),\n  {:ok, deserialized} <- ZabbixSender.Serializer.deserialize(response),\n  {:ok, decoded} <- ZabbixSender.Protocol.decode_response(deserialized)\ndo\n  if decoded.failed == 0 do\n    Logger.info(\"#{decoded.processed} values processed\")\n  else\n    Logger.warn(\"#{decoded.processed} values processed out of #{decoded.total}\")\n  end\nend\n```","ref":"readme.html#example"},{"type":"extras","title":"Known issues - ZabbixSender","doc":"Currently TLS encryption (both PSK and RSA) is not supported and there are no plans for it. A PR would be welcome though.","ref":"readme.html#known-issues"},{"type":"extras","title":"Documentation - ZabbixSender","doc":"Docs can be found at [https://hexdocs.pm/zabbix_sender](https://hexdocs.pm/zabbix_sender).","ref":"readme.html#documentation"},{"type":"extras","title":"License - ZabbixSender","doc":"ZabbixSender source code is released under MIT License.\nCheck LICENSE file for more information.","ref":"readme.html#license"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,48]}}